C*********************************************************************
C
C     PROGRAM xzcont_q
C
C     x-zʿ޺ץ(, )
C
C      1997/07/24 
C          1999/02/04 
C          2000/11/21 ; D Ѥ˽ľ
C
C*********************************************************************
      program xzcont_q
*-----------------------------------------------------
      implicit real*8 ( a-h, o-z )
*-----------------------------------------------------

#include "grid_size_M.f"

      parameter ( nbr3 = 3*((nx+6)*(nz+6)/16+1) )
*-----------------------------------------------------
      integer ibr(nbr3)
*-----------------------------------------------------
      parameter ( day = 86400.0 )
      parameter ( hour = 3600.0 )
      parameter ( PI = 3.141592D0 ) 

      real*8
     \   zgrid ( -2:nzb ),
     \   temp0 ( -2:nzb ),
     \   tpot0 ( -2:nzb ),
     \   dens0 ( -2:nzb ),
     \   ppai0 ( -2:nzb ),
     \   pres0 ( -2:nzb ),
     \   rvap0 ( -2:nzb ),
     \   qvap0 ( -2:nzb )

      real*8
     \     qvap ( -2:nxb, -2:nzb )

      real*4
     \    z0p ( 0:nz ), 
     \    p0p ( 0:nz ),
     \    d0p ( 0:nz ),
     \ temp0p ( 0:nz ),
     \ tpot0p ( 0:nz ),
     \  pai0p ( 0:nz ),
     \ rvap0p ( 0:nz ),
     \ qvap0p ( 0:nz )

      real*4 
     \      qvapp ( nx+1, nz+1 )


      character*2 mint
      character*2 lt
      character*2 date
      character*17 header

      character*100 dumy
      character CSGI*1

*-----------------------------------------------------
      open (11,file='exparam')
      read (11,*) irun
      read (11,*) time0, nloop1, nloop2, dtime, ntmoni, ntkubu, times
      read (11,*) ylat, als

      call FOPEN ( irun+1 )

      do iz = 1,9
         read(16,'(a100)') dumy
      end do

      do iz = -2, nzb
         read(16,*) ii, zgrid(iz), pres0(iz), dens0(iz), temp0(iz),
     \                     tpot0(iz), ppai0(iz), qvap0(iz), rvap0(iz)
      end do

      do iz = 0, nz
         z0p(iz)   = zgrid(iz)
         p0p(iz)   = pres0(iz)
         d0p(iz)   = dens0(iz)
         temp0p(iz)= temp0(iz)
         tpot0p(iz)= tpot0(iz)
         pai0p(iz) = ppai0(iz)
         rvap0p(iz)= rvap0(iz)
         qvap0p(iz)= qvap0(iz)
      end do

      write(6,*) 'data number = ', nloop1
      write(6,*) 'INPUT DATA BEGINING, END, & INTERVAL' 
      write(6,*) 'itb ite interval ?'
      read (*,*) itb, ite, interv

      write(6,*) 'SELECT DATA (I)' 
      write(6,*) '1; QVAP 2; QCLW 3; QRAI ?'
      read (*,*) IDN


      call sgpwsn
      read(*,*) iws

      call gropn(-iws)
      call sldiv( 'T', 2, 6 )
      call swlset( 'LALT',  .TRUE. )
      call sglset( 'LFULL', .TRUE. )
      call sglset( 'LCORNER', .FALSE. )
      call udlset( 'LMSG', .FALSE. )
      call uzfact(0.6)
*
      do it = 1, ite

         if (IDN .eq. 1) then
            read(35) time, ((qvap(ix,iz),ix=-2,nxb), iz=-2,nzb)
         else if (IDN .eq. 2 ) then
            read(36) time, ((qvap(ix,iz),ix=-2,nxb), iz=-2,nzb)
         else if (IDN .eq. 3 ) then
            read(37) time, ((qvap(ix,iz),ix=-2,nxb), iz=-2,nzb)
         else
            write(*,*) 'IDN is not correct; Stop.'
            stop
         end if

      write(0,*) 'reading time = ', time

      if ( it .ge. itb   .and.  it .le. ite ) then
         if ( mod( (it-itb), interv ) .eq. 0 ) then

            write(0,*) 'writing time = ', time

c*** Ѵ: ä LT ************************************
            time = time + times
            write(date,'(I2.2)') INT( time / day ) + 1

            time = ( time - INT( time / day ) * day ) / hour 

            if ( INT(time) .ge. 24 ) then
               time = time - 24
            end if

            write(lt, '(I2.2)') INT(time)
            write(mint, '(I2.2)') INT( MOD(time,1)*60.0 )

            header = 'day=' // date // ' ' // 'LT=' // lt // ':' // mint
c**************************************************************
c** 2-grid noize ν ***************************************

            do iz = 1,nz+1
               do ix = 1, nx+1
C                  qvapp(ix,iz) = qvap(ix-1,iz-1)
                  qvapp(ix,iz) = ( qvap(ix-2,iz-1) 
     \                 + 2.0 * qvap(ix-1,iz-1)
     \                 + qvap(ix+1,iz-1) ) / 4.0 
               end do
            end do
*
c**************************************************************

            call grfrm
            call grswnd ( 0.0, 51.2, 0.0, 20.0 )
C            call grsvpt ( 0.15, 0.95, 0.15, 0.506 )
            call grsvpt ( 0.15, 0.95, 0.1, 0.42 )
            call grstrn(1)
            call uspfit
            call grstrf
            call udpset ( 'rsizet', 0.01 )
C            call ussttl ( 'Dust Mixing Ratio[kg/kg]', 
C     \           'X[km]', '', 'Z[km]' )
            call udpset ( 'ICYCLE', 5 )
            call udgcla ( 0.0, 8.0e-5, 5.0e-6 )
C            call udgcla ( 0.0, 8.0e-5, 2.0e-6 )

c            do i = 1,4
c               TLEV2 =  2 + i 
c               TLEV1 =  TLEV2 - 1
c               TLEV2 =  TLEV2 * 10.**(-6)
c               TLEV1 =  TLEV1 * 10.**(-6)
c               IPAT = 600 + i 
c               call uestlv(TLEV1, TLEV2, IPAT)
c            end do

c            TLEV2 =  4.0e-5
c            TLEV1 =  6.e-6
c            IPAT = 605   
c            call uestlv(TLEV1, TLEV2, IPAT)
c            call uetone ( qvapp, nx+1, nx+1, nz+1 )

            call usdaxs
            call uxsttl ( 'T', header, 1. )
            call udcntz ( qvapp, nx+1, nx+1, nz+1, ibr, nbr3)
*
*
         end if
      end if

      end do

      call grcls

      call FCLOSE

      end
